//This is in no way endorsed or supported by Lego, Inc.
//use at own risk, this is not designed to alter existing data, but could cause crashes?
//or take so much time that the user 'elects' to close LW forcibly
//lscript is not well documented in the reference manuals so I may be doing things that
//I don't realize I'm doing.


//have fun and feel free to alter, copy, or do whatever you want to with this,
//I only ask that you give credit where credit is due should you use this in whole or copy
//significant portions of it, minor copying I have no reservations about
//(no clue why you would actually use this, not that efficient/effective)

//feel free to contact me via AIM at username Arngautr to say hi, ask questions, or anything else
//I like seeing what other people do using/expanding upon/learning from/fixing what I've done
//also email at rob6115@email.com

//
//-Rob Abbott

//This was designed and tested using LW7.0
//
//-always backup stuff

/*
// ****************************************************************
   18/09/04 -> Improvements from Alexx
   earthwormjim@free.fr  -  http://earthwormjim.free.fr/
   
   version 1.0
   
   - New merge code : now blocks are merged in rows, almost like real lego
   - General speed slow down... quality needs time ;)
   
   - Added parameters storing
   - Added HD Instance mode : this mode will not clone the blocks, but instead
     only keep points for each position and a block to be cloned for each surface.
     The cloning is done in Layout using the HD instance plugin ( http://www.happy-digital.com/instance.asp )
     Of course, this mode is pretty fast because only points are generated.
     
// ****************************************************************
*/


/*
// ****************************************************************
   29/08/04 -> Improvements from Alexx
   earthwormjim@free.fr  -  http://earthwormjim.free.fr/
   
   - Better code for holes problems
   - Better code for voxel
   - Added an option to not optimize Transparent blocks
     
   
// ****************************************************************
*/



/*
// ****************************************************************
   28/08/04 -> Improvements from Alexx
   earthwormjim@free.fr  -  http://earthwormjim.free.fr/
   
   - Unseen polygons are now automatically removed :)
   - No more overlapping between different surfaces,
     but now, the surface order is important : if 2 surfaces are
     sharing an edge, the blocks on this edge will have the surface
     with the lower index in the surface list.
     I need to find a workaround for this, maybe giving each surface
     a custom priority based upon the total number of polygons affected
     by it (more polygons = less priority).
     I will test it tommorow
     
   - fixed a bug causing blocks to be put only on polygons edges
   
   - NOTE : this script can now only works with LW 7.5c+ because
            I'm using the changepart() function.
   
// ****************************************************************
*/


/*
// ****************************************************************
   27/08/04 -> Improvements from Alexx
   earthwormjim@free.fr  -  http://earthwormjim.free.fr/
   
   - Fixed the holes problem...
   
// ****************************************************************
*/


/*
// ****************************************************************
   21/08/04 -> Improvements from Alexx
   earthwormjim@free.fr  -  http://earthwormjim.free.fr/
   
   - better progress bar
   - overall speed improvements
   - disabled the 'reduced blocks' mode, because it was slower (and obsolete)
   
   - holes bug still here, maybe more..
   
// ****************************************************************
*/


@warnings
@version 2.3
@script modeler
@name Legoizer

fg;
dprogress;
mulXY;
blocks_count;


main{

selmode(USER);
selpoint(CLEAR);
selpolygon(CLEAR);


//defaults

width=.0075;
height=.01;
whratio=.75;
phratio=.15;
pegsides=12;
axis=<0.0,1.0,0.0>;
mergep=true;
not_optimiz_transp_blocks=false;
usebgblock=false;
hd_instance_mode=false;

axis_x = 0.0;
axis_y = 1.0;
axis_z = 0.0;

/*
var width = globalrecall("LEGOIZER_width",0.0075);
var height = globalrecall("LEGOIZER_height",0.01);
var whratio = globalrecall("LEGOIZER_whratio",0.75);
var phratio = globalrecall("LEGOIZER_phratio",0.15);
var pegsides = globalrecall("LEGOIZER_pegsides",12);
var mergep = globalrecall("LEGOIZER_mergep",1);
var not_optimiz_transp_blocks = globalrecall("LEGOIZER_whratio",0);
var usebgblock = globalrecall("LEGOIZER_whratio",0);
var hd_instance_mode = globalrecall("LEGOIZER_hd_instance_mode",0);

var axis_x = globalrecall("LEGOIZER_axis_x",0.0);
var axis_y = globalrecall("LEGOIZER_axis_y",1.0);
var axis_z = globalrecall("LEGOIZER_axis_z",0.0);
*/
dprogress=true;

reqbegin("Legoizer");//requester (UI)
	
	
	
	
    c1=ctldistance("Block Height", height);
    c2=ctlnumber("Block Width/Height Ratio", whratio);
    c3=ctlnumber("Block Peg/Height Ratio", phratio);
    c4=ctlinteger("Block Peg Sides", pegsides);
    c5=ctlvector("Axis", <axis_x,axis_y,axis_z>);
    c6=ctlcheckbox("Display Progress",dprogress);
    c7=ctlcheckbox("Merge/Unify Points/Polys",mergep);
    c8=ctlcheckbox("Don't optimize transparent blocks", not_optimiz_transp_blocks);
    c9=ctlcheckbox("Use Block From Background", usebgblock);
    c10=ctlcheckbox("HD Instance mode", hd_instance_mode);
    
    return if !reqpost();//cancel?

    height=getvalue(c1); 
    whratio=getvalue(c2);  
    phratio=getvalue(c3);
    pegsides=getvalue(c4);
    axis=getvalue(c5);
    dprogress=getvalue(c6);
    mergep=getvalue(c7);
    not_optimiz_transp_blocks=getvalue(c8);
    usebgblock=getvalue(c9);
    hd_instance_mode=getvalue(c10);
reqend();


globalstore("LEGOIZER_width",width.asNum());
globalstore("LEGOIZER_height",height.asNum());
globalstore("LEGOIZER_whratio",whratio.asNum());
globalstore("LEGOIZER_phratio",phratio.asNum());
globalstore("LEGOIZER_pegsides",pegsides.asInt());
globalstore("LEGOIZER_mergep",mergep.asInt());
globalstore("LEGOIZER_whratio",not_optimiz_transp_blocks.asInt());
globalstore("LEGOIZER_whratio",usebgblock.asInt());
globalstore("LEGOIZER_hd_instance_mode",hd_instance_mode.asInt());

globalstore("LEGOIZER_axis_x",(axis.x).asNum());
globalstore("LEGOIZER_axis_y",(axis.y).asNum());
globalstore("LEGOIZER_axis_z",(axis.z).asNum());





if (usebgblock){
    reducedblocks=false;
}

(hour,min,sec,tick)=time();

width=height*whratio;




progress_steps=7;
if (dprogress) moninit(progress_steps,"Initializing...");



selmode(USER);

pcnt=polycount();
if (pcnt[1]==0){
    info("Error:no data visible");
    return false;
}


fg=lyrfg();
selpolygon(CLEAR);
base_box=boundingbox();

bg=lyrbg();



// ******************************************************************
// STEP 1 : define misc variables
// ******************************************************************



// contains the list of surface used by the current mesh, sorted from min to max polycount per surfaces
surfaces_list = get_surfaces_list(1);

if(hd_instance_mode){
	lyrsetfg(fg);
	layer_list = get_layer_list(surfaces_list);
	fill_layer_list(layer_list[1]);
	fill_layer_list(layer_list[2]);
}

emptylyrs=lyrempty();//had to call twice since it only seems to find the 4 nearest empty layers

legolyr=emptylyrs[1]; lyrsetfg(legolyr); editbegin(); addpoint(<0,0,0>); editend();

//a temp layer, holds cutters and some other stuff
swap=emptylyrs[2]; lyrsetfg(swap);  editbegin(); addpoint(<0,0,0>); editend();

//holds some other temp stuff
swap2=emptylyrs[3]; lyrsetfg(swap2);  editbegin(); addpoint(<0,0,0>); editend();

//for moving block around
swap3=emptylyrs[4]; lyrsetfg(swap3);  editbegin(); addpoint(<0,0,0>); editend();

emptylyrs=lyrempty();

swap4=emptylyrs[1]; lyrsetfg(swap4);  editbegin(); addpoint(<0,0,0>); editend();



do_progress();


// ******************************************************************
// STEP 2 : duplicate base mesh
// ******************************************************************


emptylyrs=lyrempty();


// MAKE BLOCK
blocklyr=emptylyrs[1];//one block for moving around and copying much latter

lyrsetfg(blocklyr);

if (usebgblock){
    lyrsetfg(bg);
    copy();
    lyrsetfg(blocklyr);
    paste();
} else{
    makeblock(height, width, phratio, pegsides);
}


lyrsetfg(fg);
copy();//copys current selection so as not to disturb original object

tempobject = emptylyrs[2];//replacement of original object

lyrsetfg(tempobject);
paste();


lyrsetfg(legolyr); delete();
lyrsetfg(swap); delete();
lyrsetfg(swap2); delete();
lyrsetfg(swap3); delete();
lyrsetfg(swap4); delete();

if (hd_instance_mode){
	empty_layer_list(layer_list[1]);
	empty_layer_list(layer_list[2]);
}


do_progress();


// ******************************************************************
// STEP 3 : set axis
// ******************************************************************

lyrsetfg(tempobject);

setaxis(axis);//orients object so blocks pointing up (Y+) point along 'axis' when unoriented

bboxoriginal=boundingbox();
move(-bboxoriginal[1]);

do_progress();


// ******************************************************************
// STEP 4 : some clean up
// ******************************************************************

lyrsetfg(tempobject);

selpolygon(CLEAR);
pcnt=polycount();
pntcnt=pointcount();
mergepoints();
unifypols();
unweld();

//deletes polys w/ <3 pts
pcnt=polycount();
if (pcnt[2]!=0 || pcnt[3]!=0){
    selpolygon( SET, NVLT, 3);
    delete();
}

//curves deleted above ?
//tries to delete curves
selpolygon(CLEAR);
pntcnt=pointcount();
selpolygon( SET, CURVE);
if (pointcount()>0 && pointcount()!=pntcnt){
    delete();
}

//freezes curves and subdivs
selpolygon(CLEAR);
selpolygon(SET);
selpolygon(CLEAR, FACE);
freezecurves();

//Triples polys w/ >4 pts or noplaner
selpolygon(CLEAR);
//pcnt=polycount();
//

selpolygon(SET, NONPLANAR);
selpolygon(SET, NVGT, 4);

pcnt2=polycount();
if (pcnt2[1]!=pcnt[1]){
	triple();
}

selpolygon(CLEAR);
pcnt=polycount();

do_progress();


// ******************************************************************
// STEP 5 : final clean up
// ******************************************************************

//puts stuff back together
selpolygon(CLEAR);
mergepoints();
unifypols();
selpolygon(CLEAR);
pcnt=polycount();
pntcnt=pointcount();

do_progress();

// ******************************************************************
// STEP 6 : check for data
// ******************************************************************

if (pcnt[1]==0){
    info("Error:no useful data visible");
    return false;
}//no polys left


do_progress();


// ******************************************************************
// STEP 7 : init some vars
// ******************************************************************


//set up cutter sizes
bbox=boundingbox();

box_center = bbox[1] + ((bbox[2] - bbox[1]) / 2);
bb=bbox[2];

bb.x=(integer(bb.x/width) + integer(bb.x/width)%2 + 2)*width;
bb.y=(integer(bb.y/height) + integer(bb.y/height)%2 + 2)*height;
bb.z=(integer(bb.z/width) + integer(bb.z/width)%2 + 2)*width;


// shift the object a little, to avoid the holes problem
// this was caused by errors in the slice when edge were coplanar.
decal = <0.001 , 0.001 , 0.001> + <width,height,width> / 100.0;
move(decal);

rotate( 0.001 , X , box_center );
rotate( 0.001 , Y , box_center );
rotate( 0.001 , Z , box_center );

do_progress();
monend();


// ******************************************************************
// STEP 8 : cut mesh 1/3
// ******************************************************************

w2 = width * 5;
h2 = height * 5;

sl = (round(bb.x/width,0) + 3)/2;
moninit(sl,"Cut 1/3");

	lyrsetfg(swap);
	
	for(i=0;i<=sl;i++){
		px = -width + (i*width*2);
		
		makebox(<px,-0.1,-0.1>,<px+width,-0.1,bb.z+0.1>,<1,1,1>);
		
		lyrsetfg(tempobject);
		lyrsetbg(swap);
		
		//selpolygon(SET,VOLINCL,<px - width,-0.1,-0.1>,<px+width+width,bb.y+0.1,bb.z+0.1>);
		tt = axisdrill(SLICE, Y);
		//selpolygon(CLEAR);
		
		// if an error occurs during the slice, the shift the mesh, and slice it again
		cnt=0;
		while(tt!=0){
			if(cnt==0) move(<0.001,0.001,0.001>);
			if(cnt==1) move(<-0.002,-0.002,-0.002>);
			if(cnt==2) rotate(0.001,Y,box_center);
			tt = axisdrill(SLICE, Y);
			if(cnt==2) break;
		}
		if(tt!=0) error("Slice problem on Y axis");

		lyrsetfg(swap);
		delete();
		do_progress();
		
	}
monend();

// ******************************************************************
// STEP 9 : create second cutter and cut mesh 2/3
// ******************************************************************

sl = (round(bb.z/width,0)+3)/2;
moninit(sl,"Cut 2/3");
	lyrsetfg(swap);
	for(i=0;i<=sl;i++){
		
		pz = -width + (i*width*2);
		
		makebox(<-0.1,-0.1,pz> ,<bb.x + 0.1,-0.1,pz+width>,<1,1,1>);
				
		
		lyrsetfg(tempobject);
		lyrsetbg(swap);
		
		selpolygon(SET,VOLINCL,<-0.1,-0.1,pz - w2>,<bb.x + 0.1,bb.y + 0.1,pz+w2>);
		tt = axisdrill(SLICE, Y);
		selpolygon(CLEAR);
				
		cnt=0;
		while(tt!=0){
			if(cnt==0) move(<0.001,0.001,0.001>);
			if(cnt==1) move(<-0.002,-0.002,-0.002>);
			if(cnt==2) rotate(0.001,Y,box_center);
			tt = axisdrill(SLICE, Y);
			if(cnt==2) break;
		}
		if(tt!=0) error("Slice problem on Y axis");

		lyrsetfg(swap);
		delete();
		do_progress();
		
	}
monend();

// ******************************************************************
// STEP 10 : create third cutter and cut mesh 3/3
// ******************************************************************

sl = (round(bb.y/height,0)+3)/2;
moninit(sl,"Cut 3/3");
	lyrsetfg(swap);
	for(i=0;i<=sl;i++){
		py = -height + (i*height*2);
		
		makebox(<-0.1,py,-0.1>,<bb.x+0.1,py+height,-0.1> ,<1,1,1>);
		
		lyrsetfg(tempobject);
		lyrsetbg(swap);
		
		selpolygon(SET,VOLINCL,<-0.1,py - h2,-0.1>,<bb.x+0.1,py + h2,bb.z+0.1>);
		tt = axisdrill(SLICE, Z);
		selpolygon(CLEAR);
		
		cnt=0;
		while(tt!=0){
			if(cnt==0) move(<0.001,0.001,0.001>);
			if(cnt==1) move(<-0.002,-0.002,-0.002>);
			if(cnt==2) rotate(0.001,Z,box_center);
			tt = axisdrill(SLICE, Z);
			if(cnt==2) break;
		}
		if(tt!=0) error("Slice problem on Z axis");

		lyrsetfg(swap);
		delete();
		do_progress();		
		
	}
monend();


// ******************************************************
// get real voxel size
// ******************************************************
lyrsetfg(tempobject);

quantize(<width,height,width>);
mergepoints();
bbox=boundingbox();
bb=bbox[2];
selpoint(CLEAR);

// needs to use round(float,0) to be sure to have the right integer value
// tips given by Stuart Aitken, thanks ;)
blocks_count = (<round(bb.x / width , 0) , round(bb.y / height , 0) , round(bb.z / width , 0) >) + <3,3,3>; // dont know why I now need to add <3,3,3> instead of <1,1,1>....

optimize_blocks=1;

if(optimize_blocks == 1){
	// define voxel multidimensionnal array
	
	block_array_empty = array(blocks_count.x);
	
	b = array(blocks_count.z);
	
	for(i=1;i<=blocks_count.x;i++){
		block_array_empty[i] = b;
	}
	
}

blocks_array = block_array_empty;
blocks_arrayprev = block_array_empty;
blocks_arraynext = block_array_empty;

// ******************************************************
// Start of main lego building
// ******************************************************

totbricks=0;
selmode(USER);

w2 = width / 2.0;
h2 = height / 2.0;

w3 = width * 1.5;
h3 = height * 1.5;


num_surf=0;


for(ss=1;ss<=sizeof(surfaces_list);ss++){
	surf=surfaces_list[ss];
	num_surf++;

	// get surface properties
	surfObj = Surface(surf);
	isTransp = false;
	if(not_optimiz_transp_blocks) isTransp = (surfObj.getValue(SURFTRAN)>0);

	// swap to temporary quantized object layer	
    lyrsetfg(tempobject);

	// select only polygons suing the current surface
    selpolygon(CLEAR);
    pcnt=polycount();
    selpolygon(SET, SURFACE, surf);
    pcnt2=polycount();

	
    // HD Instance mode : only copy points
    if(hd_instance_mode){
    	sel_polypoints(surf);
    	cut();
    	
    	lyrsetfg(layer_list[2][num_surf]);
    	
    	paste();
    	
    }else{
    
	    
	    // COPY QUANTIZED POINTS
		bb_prev = boundingbox(); // get the boundingbox of quantized points
		
		cut();
	    
	   	lyrsetfg(swap2);
	    
	    selpolygon(CLEAR);
	    //make way for the new stuff
	    delete();
	    
	    // paste the geometry
	    paste();
	    tot_swap2=pointcount();
	    
	    sleep(1);
	    
		// COPY  BOUNDARIES POINTS
		
		lyrsetfg(tempobject);
		
		if(bb_prev[1]!=nil){
			selpoint(SET,VOLUME, bb_prev[1] - <width,height,width>*1.5 , bb_prev[2] + <width,height,width>*1.5 );
			bb = boundingbox();
			
			copy();
		
			lyrsetfg(swap4);
			selpolygon(CLEAR);
			delete();
			paste();
			
			tot_swap4=pointcount();
			if(bb[1] == nil){
				bb = bb_prev;
			}else{
				if(bb[1]>bb_prev[1]) bb[1] = bb_prev[1];
				if(bb[2]<bb_prev[2]) bb[2] = bb_prev[2];
			}
		
		}else{
			bb=@nil,nil@;
		}
		
		if(bb[1] != nil){
			ystart = bb[1].y;
			yend = bb[2].y + height*2;
		
			num=0;
			nextjj=0;
			nextpnt=array;
			nextpos=array;
			
			moninit( tot_swap2 / 50 , "Constructing legos for surface [ "+surf+" ]");
			
			// loop through each lines of the lego structure
			for(r=ystart;r<=yend;r+=height){
	
				num++;
				
				blocks_arrayprev = blocks_array;
				blocks_array = blocks_arraynext;
				blocks_arraynext = block_array_empty;
	
				lyrsetfg(swap4);
				selpoint(CLEAR);
				
				v1=<bb[1].x - w2,r - h2,bb[1].z - w2>;
				v2=<bb[2].x + w2,r + h2,bb[2].z + w2>;
				
				
				selpoint(SET,VOLUME, v1 , v2 );
				
				pcount=pointcount();
				
				ok = (pcount>0);
			    if(pcount == tot_swap4 && ok){
			    	editbegin();
			    		tmp = pointinfo(points[1]);
			    	editend();
			    	
			    	ok = is_point_inside_box(tmp,@v1,v2@);
			   	}
		
				if(ok){
				    editbegin();
				        for (j=1;j<=pcount ;j++ ){
							tmp = pointinfo(points[j]);
				
							if(optimize_blocks == 1){
								XX = round(tmp.x / width , 0)+1;
								ZZ = round(tmp.z / width , 0)+1;
							
								blocks_arraynext[XX][ZZ] = 3;
							}
						}
				    editend();
				}
				
				
				
				lyrsetfg(swap2);
				selpoint(CLEAR);
				selpoint(SET,VOLUME, v1 , v2 );
	
			    pcount=pointcount();
			    
			    ok = (pcount>0);
			    if(pcount == tot_swap2 && ok){
			    	editbegin();
			    		tmp = pointinfo(points[1]);
			    	editend();
			    	
			    	ok = is_point_inside_box(tmp,@v1,v2@);
			   	}
			    
			    
			    pnt=nextpnt;
			    pos=nextpos;
			    
			    nextpnt=array;
			    nextpos=array;
			    jj=0;
				
				if(ok){
				    editbegin();
				        for (j=1;j<=pcount ;j++ ){
							tmp = pointinfo(points[j]);
				
							if(optimize_blocks == 1){
								XX = round(tmp.x / width , 0)+1;
								ZZ = round(tmp.z / width , 0)+1;
								
								if( blocks_arraynext[XX][ZZ].isNil() ){
									jj++;
									nextpos[jj] = <XX,0,ZZ> ;
									nextpnt[jj] = tmp.asVec();
									blocks_arraynext[XX][ZZ] = 1;
								}
							}else{
								jj++;
								nextpnt[jj] = tmp.asVec();
							}
						}
				    editend(); //gets the coordinates of the points
			    }
				
				if(num>1 && nextjj>0){
							
				    k=70;
				    pcount=nextjj;
				    
				    for (i=k;i<pcount+k ;i+=k ){
				        km=i - k + 1;
				        if (i>pcount){
				            i=pcount;
				        }
				   
				       //	lyrsetfg(fg);
				       	lyrsetfg(swap);
				       	do_progress();
				       	
				        // clone blocks
				        
				        lyrsetfg(blocklyr);
				        changesurface(surf); //sets the block's surface before making object
				        
				        copy(); // copy the block into memory, only one time
				        
				        lyrsetfg(swap); // back to construction layer
				        
				        // build legos
				        for (j=km;j<=i ; j++){
							
							if(optimize_blocks == 1){
					        	if(blocks_array[pos[j].x][pos[j].z] != 2 ){
					        	 	
					        	 	blocks_array[pos[j].x][pos[j].z] = 2;
					        	 	totbricks++;
					        	 	
					            	paste();        // paste it
					            	move(pnt[j]);   // move it to the right position
					            	
					            	//-----------------------------------------------------
					            	// remove hidden parts
					            	if(!isTransp && !usebgblock){
						            	del=false;
						            	
						            	if(pos[j].x > 1){ 
						            		if(blocks_array[pos[j].x - 1][pos[j].z] != nil && blocks_array[pos[j].x - 1][pos[j].z] != 3  ){
						            			selpolygon(SET,PART,"Lego_Xl");
						            			del=true;
						            		}
						            	}
		
						            	
						            	if(pos[j].x < blocks_count.x){ 
						            		if(blocks_array[pos[j].x + 1][pos[j].z] != nil && blocks_array[pos[j].x + 1][pos[j].z] != 3   ){
						            			selpolygon(SET,PART,"Lego_Xh");
						            			del=true;
						            		}
						            	}
		
						            	
					            		if(blocks_arrayprev[pos[j].x][pos[j].z] != nil && blocks_arrayprev[pos[j].x][pos[j].z] != 3   ){
					            			selpolygon(SET,PART,"Lego_Yl");
					            			del=true;
					            		}
		
						            	
						            	
					            		if(blocks_arraynext[pos[j].x][pos[j].z] != nil && blocks_arraynext[pos[j].x][pos[j].z] != 3   ){
					            			selpolygon(SET,PART,"Lego_Yh");
					            			selpolygon(SET,PART,"Lego_peg");
					            			del=true;
					            		}
		
						            	if(pos[j].z > 1){ 
							            	if(blocks_array[pos[j].x][pos[j].z - 1] != nil && blocks_array[pos[j].x][pos[j].z - 1] != 3   ){
							            		selpolygon(SET,PART,"Lego_Zl");
							            		del=true;
							            	}
										}
		
										if(pos[j].z < blocks_count.z){ 
						            		if(blocks_array[pos[j].x][pos[j].z + 1] != nil && blocks_array[pos[j].x][pos[j].z + 1] != 3   ){
						            			selpolygon(SET,PART,"Lego_Zh");
						            			del=true;
						            		}
						            	}
						            	if(del) delete();
						            	
					            	}
					            	//-----------------------------------------------------
								}
							}
							
							// OBSOLETE PART
							// optimisation based on volume selections, very slow...
							if(optimize_blocks==2){
				
								lyrsetfg(swap);
								
								totbricks++;
					        	 	
					           	paste();        // paste it
					           	move(pnt[j]);   // move it to the right position
				
								lyrsetfg(swap2);
								
								Xl=0;
								Xh=0;
								Yl=0;
								Yh=0;
								Zl=0;
								Zh=0;
				
								// test droite
								selpoint(SET,VOLUME, pnt[j] + <w2,-h2,-w2> , pnt[j] + <w3 , h2 , w2> );
								pc=pointcount();
								if(pc==1) Xh=1;
				
								selpoint(CLEAR);
				
								// test gauche
								selpoint(SET,VOLUME, pnt[j] + <-w3,-h2,-w2> , pnt[j] + <-w2 , h2 , w2> );
								pc=pointcount();
								if(pc==1) Xl=1;
				
								selpoint(CLEAR);
						
								// test haut
								selpoint(SET,VOLUME, pnt[j] + <-w2,h2,-w2> , pnt[j] + <w2 , h3 , w2> );
								pc=pointcount();
								if(pc==1) Yh=1;
				
								selpoint(CLEAR);
						
								// test bas
								selpoint(SET,VOLUME, pnt[j] + <-w2,-h3,-w2> , pnt[j] + <w2 , -h2 , w2> );
								pc=pointcount();
								if(pc==1) Yl=1;
				
								selpoint(CLEAR);
						
								// test devant
								selpoint(SET,VOLUME, pnt[j] + <-w2,-h2,w2> , pnt[j] + <w2 , h2 , w3> );
								pc=pointcount();
								if(pc==1) Zh=1;
				
								selpoint(CLEAR);
								
								// test derriere
								selpoint(SET,VOLUME, pnt[j] + <-w2,-h2,-w3> , pnt[j] + <w2 , h2 , -w2> );
								pc=pointcount();
								if(pc==1) Zl=1;
				
								
								lyrsetfg(swap);
				
								
								if(Xl>0) selpolygon(SET,PART,"Lego_Xl");
								if(Xh>0) selpolygon(SET,PART,"Lego_Xh");
								if(Yl>0) selpolygon(SET,PART,"Lego_Yl");
								if(Yh>0){
									selpolygon(SET,PART,"Lego_Yh");
									selpolygon(SET,PART,"Lego_peg");
								}
								if(Zl>0) selpolygon(SET,PART,"Lego_Zl");
								if(Zh>0) selpolygon(SET,PART,"Lego_Zh");
						
								if((Xl + Xh + Yl + Yh + Zl + Zh)>0) delete();
								
							}// if(optimize_blocks==2){
							
							
							if(optimize_blocks==0){
				           		// no optimization
				    	       	totbricks++;
					           	paste();        // paste it
					          	move(pnt[j]);   // move it to the right position
				           }
				           
				           
				           selhide();      // then hide it, so the next pasted block will be moved alone
				           
				        }
				

				            
				    }// for (k=
				    
				    
				}// if num>1
				nextjj=jj;
				
				
				lyrsetfg(swap);
				selunhide();        // unhide all blocks
				
				// MERGE ROWS
		        if (mergep){
			        mergepoints();
			        
			        selpolygon(SET,PART,"Lego_Xl");
			        mergepols();
			        selpolygon(CLEAR);
			        
			        selpolygon(SET,PART,"Lego_Xh");
			        mergepols();
			        selpolygon(CLEAR);
			        
			        selpolygon(SET,PART,"Lego_Yl");
			        mergepols();
			        selpolygon(CLEAR);
			        
			       	selpolygon(SET,PART,"Lego_Yh");
			        mergepols();
			        selpolygon(CLEAR);
			        
			       	selpolygon(SET,PART,"Lego_Zl");
			       	mergepols();
			        selpolygon(CLEAR);
			        
			       	selpolygon(SET,PART,"Lego_Zh");
			        mergepols();
					selpolygon(CLEAR);
				}
		        // MOVE THE BLOCKS TO THE FINAL LAYER
		        cut();
		        lyrsetfg(legolyr);
		        paste();
	
				
			}// for(r=
			monend();
		}// if(bb(1] != nil)
		
	    lyrsetfg(legolyr);
			
		//cleans everything up
	    if (mergep){
	        mergepoints();
	        unifypols();
	    }
	
	    selhide();
	    
	}// if(hd_instance_mode)
	
}// for(surf=

blocks_array = 0; // trying to free memory !
blocks_arrayprev = 0;
blocks_arraynext = 0;

if(hd_instance_mode){
	lyrsetfg(blocklyr);
	cut();

	for(l=1;l<=sizeof(layer_list[1]);l++){
		lyrsetfg(layer_list[1][l]);
		paste();
		changesurface(surfaces_list[l]);
	}
	
	lyrsetfg(layer_list[2]);
	    	
    totbricks = pointcount();
}else{
	lyrsetfg(legolyr);
	selunhide();
	
	if (mergep){
		selpolygon(CLEAR);			        
		selpolygon(SET,PART,"Lego_Yl");
		mergepols();
		selpolygon(CLEAR);
					        
		selpolygon(SET,PART,"Lego_Yh");
		mergepols();
		selpolygon(CLEAR);
	
		selpolygon(SET,PART,"Lego_peg");
		selhide();
		
		// deletes bad points
		selpoint(SET,NPEQ,0);
		selpoint(SET,NPEQ,2);
		delete();
		
		selunhide();
	}
	
	//put everything back together and where it belongs, erase temp stuff---
	lyrsetfg(swap2);
	delete();
	lyrsetfg(swap);
	delete();
	lyrsetfg(blocklyr);
	delete();
	lyrsetfg(tempobject);
	delete();
	
	lyrsetfg(legolyr);
}
move(bboxoriginal[1]);//moves back to original location (moved away to make math slightly easier...
unsetaxis(axis);

final_box = boundingbox();
base_center = base_box[1] + (base_box[2] - base_box[1]) / 2;
final_center = final_box[1] + (final_box[2] - final_box[1]) / 2;
mv = base_center - final_center;
move(mv);

lyrsetbg(fg);

if (dprogress){
    i=0;

    (hour2,min2,sec2,tick2)=time();
    h=hour2 - hour;
    m=min2 - min;
    s=sec2 - sec;
    
    if (m<0){
        h-=1;
        m+=60;
    }
    if (s<0){
        m-=1;
        s+=60;
    }
	
	message = totbricks.asStr()+" bricks<br>";
    if (h>0){
        message += ("Process took " + h + " hour(s),  " + m + " minute(s),  " + s + " second(s)");
    }else   if (m>0){
        message += ("Process took " + m + " minute(s),  " + s + " second(s)");
    }else if (s>0){
        message += ("Process took " + s + " second(s)");
    }
	info(message);
}//end progress bar

}

//-----------------------------------------------------------------------------------------

makeblock: i_height, i_width, i_phratio, i_pegsides{
    selmode(USER);
    selpolygon(CLEAR);

    makedisc(<i_width/4, i_height*i_phratio/2,i_width/4>,i_height,i_height*(1+i_phratio), Y, i_pegsides, 1,<i_width/2,i_height*(1+i_phratio/2),i_width/2>);
    
    // delete bottom poly of peg
    selpolygon(SET, POLYNDX, 1);
    delete();
    
    
    // assign a part name to the peg
    //pcnt=polycount();
    //selpolygon(SET, POLYNDX, pcnt[1]);
    selpolygon(CLEAR);
    
    changepart("Lego_peg");
    
    // hide the peg
    selhide();
    
    // create main block
    makebox(<0.0,0.0,0.0>,<i_width,i_height,i_width>);
    
    pcnt=polycount();
    selpolygon(SET, POLYNDX, 1); // -X
    changepart("Lego_Xl");
    selpolygon(CLEAR);

    selpolygon(SET, POLYNDX, 6); // +X
    changepart("Lego_Xh");
    selpolygon(CLEAR);

    selpolygon(SET, POLYNDX, 2); // -Y
    changepart("Lego_Yl");
    selpolygon(CLEAR);

    selpolygon(SET, POLYNDX, 4); // +Y
    changepart("Lego_Yh");
    selpolygon(CLEAR);

    selpolygon(SET, POLYNDX, 5); // -Z
    changepart("Lego_Zl");
    selpolygon(CLEAR);
    
    selpolygon(SET, POLYNDX, 3); // +Z
    changepart("Lego_Zh");
    selpolygon(CLEAR);


    selunhide();
    
}//makes a block with a little peg on top, deletes bottom portion of the peg careful as it clears clipboard





setaxis: i_axis{//rotates an axis to <0,1,0>//lots of math, it works I think...only applies to selected polys//done before I noticed the normalize() function
        
    if (i_axis.x==0 && i_axis.y==0 && i_axis.z==0){ //<0,0,0> was entered
        info("your axis is invalid: Y (<0,1,0>) will be used instead");
        i_axis=<0.0,1.0,0.0>;
    }

    if (i_axis.x!=0){
        rotate(-180.0/PI*atan(abs(i_axis.z)/abs(i_axis.x)),Y);
    }else{if (i_axis.z!=0){
        rotate(-90,Y);
    }}
    if (i_axis.x!=0 || i_axis.z!=0){//really doesn't need to be here but...
    if (i_axis.x<=0 && i_axis.z<=0){
        rotate(-180,Y);
    }else{ if (i_axis.x>0 && i_axis.z<0){
        rotate(2*180.0/PI*atan(abs(i_axis.z)/abs(i_axis.x)),Y);
    }else{ if (i_axis.x<0 && i_axis.z>0){
        rotate(-2*(90 - 180.0/PI*atan(abs(i_axis.z)/abs(i_axis.x))),Y);
    }}}}

    if (i_axis.y<0){
        rotate(-180,Z);
    }
    if (i_axis.y!=0){
        rotate(-180.0/PI*atan(sqrt(i_axis.x*i_axis.x +i_axis.z*i_axis.z)/i_axis.y),Z);
    }else{
        rotate(-90,Z);
    }
}

unsetaxis: i_axis{//rotates from the vector <0,1,0> to 'axis'
    if (i_axis.x==0 && i_axis.y==0 && i_axis.z==0){ //<0,0,0> was entered
        i_axis=<0.0,1.0,0.0>;
    }
    
    if (i_axis.y<0){
        rotate(180,Z);
    }

    if (i_axis.y!=0){
        rotate(180.0/PI*atan(sqrt(i_axis.x*i_axis.x +i_axis.z*i_axis.z)/i_axis.y),Z);
    }else{
        rotate(90,Z);
    }


    if (i_axis.x!=0){
        rotate(180.0/PI*atan(abs(i_axis.z)/abs(i_axis.x)),Y);
    }else{if (i_axis.z!=0){
        rotate(90,Y);
    }}
    if (i_axis.x!=0 || i_axis.z!=0){
    if (i_axis.x<=0 && i_axis.z<=0){
        rotate(180,Y);
    }else{ if (i_axis.x>0 && i_axis.z<0){
        rotate(-2*180.0/PI*atan(abs(i_axis.z)/abs(i_axis.x)),Y);
    }else{ if (i_axis.x<0 && i_axis.z>0){
        rotate(2*(90 - 180.0/PI*atan(abs(i_axis.z)/abs(i_axis.x))),Y);
    }}}}

}

do_progress
{
	sleep(1);
    if (dprogress){
        if(monstep()) error("Aborted by user !");
        sleep(1);
    }
}

is_point_inside_box: aPoint, aBox
{
	if( aPoint.x < aBox[1].x || aPoint.x > aBox[2].x) return false;
	if( aPoint.y < aBox[1].y || aPoint.y > aBox[2].y) return false;
	if( aPoint.z < aBox[1].z || aPoint.z > aBox[2].z) return false;
	return true;
}

get_layer_list: surfaces
{
	tmp = array;
	tmp2 = array;
	for(i=1;i<=sizeof(surfaces);i++){
		emptylyrs=lyrempty(); //had to call twice since it only seems to find the 4 nearest empty layers
		tmp += emptylyrs[1];
		tmp2 += emptylyrs[2];
		
		lyrsetfg(emptylyrs[1]); editbegin(); addpoint(<0,0,0>); editend();
		setlayername(surfaces[i] + "_block");
		
		lyrsetfg(emptylyrs[2]); editbegin(); addpoint(<0,0,0>); editend();
		setlayername(surfaces[i] + "_points");
	}
	
	lyrsetfg(tmp);
	
	delete();
	
	lyrsetfg(tmp2);
	
	delete();

	
	tt = array;
	
	tt[1] = tmp;
	tt[2] = tmp2;
	
	return tt;
}

empty_layer_list: tmp
{
	for(i=1;i <= sizeof(tmp);i++){
		lyrsetfg(tmp[i]);
		delete();
	}
}

fill_layer_list: tmp
{
	for(i=1;i <= sizeof(tmp);i++){
		lyrsetfg(tmp[i]);
		editbegin();
		addpoint(<0,0,0>);
		editend();
	}
}

get_surfaces_list: sorted
{
	
	selmode(USER);
	selpoint(CLEAR);
	selpolygon(CLEAR);
	
	pcnt = polycount();
	
	tmp = array;
	tmpsort = array;
	
	for(surf = nextsurface(); surf!=nil ; surf = nextsurface(surf) ){//decided to do make scene surface by surface
		selmode(USER);
	    selpolygon(CLEAR);
	   
	    selpolygon(SET, SURFACE, surf);
	    pcnt2=polycount();

	    if (pcnt[1] == pcnt2[1] && nextsurface(surf)!=nil){
	    
	        if (pcnt2[1]==0) break;
		        
	        editbegin();
	            polysurf=polyinfo(polygons[1]);
	        editend();
	        
	        if (polysurf[1] == surf){
		    	tmp += surf;
		    	tmpsort += strright("000000000000000" + (pcnt2[1]).asStr() , 15) + surf;
		    	break;
			}
			
	    }else{
	    	if (pcnt2[1]>0){
	   		
				editbegin();
					polysurf=polyinfo(polygons[1]);
				editend();
	
	    		if (polysurf[1].asStr() == surf.asStr()){
					tmp += surf;
					tmpsort += strright("000000000000000" + (pcnt2[1]).asStr() , 15) + surf;
				}
	    	}
	    }
	}
	
	if(sorted==-1 || sorted==1){
		
		if(sorted==1){
			tmpsort.sortA();
		}else{
			tmpsort.sortD();
		}
		
		tmp = array;
		
		for(i=1;i<=sizeof(tmpsort);i++){
			tmp += strright(tmpsort[i],size(tmpsort[i]) - 15);
		}
		
	}
	
	selmode(USER);
	selpoint(CLEAR);
	selpolygon(CLEAR);

	return tmp;
}



sel_polypoints: aSurf
{

	selmode(USER);
	tmp = array;
	editbegin();
		pcnt=polycount();
		pcnt=pcnt[1];
		
		if (pcnt==0){
			editend();
			return 0;
		}
		
		poly_lst=polygons;
		
	editend();
	
		selpolygon(CLEAR);
	
	editbegin();
		
		totpcnt=polycount();
		totpcnt=totpcnt[1];
		
		if(totpcnt==pcnt){
			inf = polyinfo(polygons[1]);
			
			editend();
			
			selpoint(CLEAR);
			if(inf[1]!=aSurf) return 0;
			
			editbegin();
		}
		
		tmp = array;
		lst = array;
		nb=0;
		nb2=0;
		
		
		
		foreach(p,poly_lst){
			inf = polyinfo(p);
	
			inf[1] = nil;
			inf.pack();
			inf.trunc();
			
			foreach(id,inf){
				nb++;
				lst[nb] = id;
			}
			
			if(nb>500){
				nb=0;
				lst.sortA();
				lst.reduce();
				lst.pack();
				lst.trunc();
				nb2++;
				tmp[nb2]= lst;
				lst = array;
			}
			
		}
		
		if (sizeof(lst)>0){
			lst.sortA();
			lst.reduce();
			lst.pack();
			lst.trunc();
			nb2++;
			tmp[nb2] = lst;
		}
		
	editend();
	
	tmp.sortA();
	tmp.reduce();
	tmp.pack();
	tmp.trunc();
	
	tot=0;
	selpoint(CLEAR);
	foreach(lst,tmp){
		selpoint(SET,POINTID,lst);
		tot+=sizeof(lst);
	}
	
	return tot;
}